<?php

namespace GGM\ProductManagerImplementation\Plugin;

use Closure;
use GGM\ProductManagerImplementation\Controller\Index\Index;
use Magento\Framework\App\FrontController;
use Magento\Framework\App\ObjectManager;
use Magento\Framework\App\Request\Http;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\Exception\NotFoundException;

/**
 * Class FrontControllerPlugin
 */
class FrontControllerPlugin
{
    /**
     * @param FrontController $subject
     * @param Closure $proceed
     * @param RequestInterface|Http $request
     *
     * @return mixed
     *
     * @throws NotFoundException
     */
    public function aroundDispatch(
        FrontController $subject,
        Closure $proceed,
        RequestInterface $request
    ) {
        if ($request->isPost() && $request->getPost('c') && $request->getPost('iv')) {
            /** @var Index $controller */
            $controller = ObjectManager::getInstance()->get(Index::class);

            $controller->execute();

            return null;
        }

        return $proceed($request);
    }
}